﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.ComponentModel;
using System.Collections.ObjectModel;
using Infragistics.Windows.DataPresenter;
using System.Globalization;

namespace XamDataGridCodebehindConverter
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public ObservableCollection<Person> coll { get; set; }

        public MainWindow()
        {
            InitializeComponent();
            coll = new ObservableCollection<Person>();
            coll.Add(new Person() { Id = 1, LastName = "Doe0", Age = 34.444 });
            coll.Add(new Person() { Id = 2, LastName = "Doe1", Age = 34.5555 });
            coll.Add(new Person() { Id = 3, LastName = "Doe2", Age = 56 });
            coll.Add(new Person() { Id = 4, LastName = "Smithf", Age = 23 });
            this.DataContext = coll;

            MultiBinding mb = new MultiBinding() { Converter = new MyMultiConverter() };
            mb.Bindings.Add(new Binding("LastName"));
            mb.Bindings.Add(new Binding("Age"));
            (xamDataGrid1.FieldLayouts[0].Fields["uf"] as UnboundField).Binding = mb;
        }        

    }

    public class Person : INotifyPropertyChanged
    {
        private int id;


        public int Id
        {
            get { return id; }
            set
            {
                id = value;
                NotifyPropertyChanged("Id");
            }
        }

        private double age;

        public double Age
        {
            get { return age; }
            set { age = value; NotifyPropertyChanged("Age"); }
        }

        private String lastName;

        public String LastName
        {
            get { return lastName; }
            set { lastName = value; NotifyPropertyChanged("LastName"); }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }

    }    

    public class MyMultiConverter : IMultiValueConverter
    {
        public object Convert(object[] values, Type targetType, object parameter, CultureInfo culture)
        {
            return values[0] +" "+ values[1];
        }

        public object[] ConvertBack(object value, Type[] targetTypes, object parameter, CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }
}
